#
# spec file for package projectM
#
# Copyright (c) 2017 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%undefine _isqt5
%define _oname  projectM
Name:           projectM
Version:        2.1.0
Release:        14.5
Summary:        An Awesome Music Visualizer
License:        LGPL-2.1+
Group:          Productivity/Multimedia/Sound/Visualization
Url:            http://projectm.sourceforge.net
Source0:        https://sourceforge.net/projects/projectm/files/%{version}/%{_oname}-complete-%{version}-Source.tar.gz
# PATCH-FIX-UPSTREAM projectM-2.1.0-fix-isnan-gcc6.patch -- fix build with GCC6 (patch from upstream development branch)
Patch0:         projectM-2.1.0-fix-isnan-gcc6.patch
# PATCH-FIX-OPENSUSE projectM-2.1.0-no-return-in-nonvoid.patch -- fix rpmlint warning
Patch1:         projectM-2.1.0-no-return-in-nonvoid.patch
# PATCH-FIX-OPENSUSE projectM-2.1.0-SUSE_misc.patch -- address a few SUSE-specific issues
Patch2:         projectM-2.1.0-SUSE_misc.patch
%if 0%{?_isqt5}
# PATCH-FIX-OPENSUSE projectM-2.1.0-Qt5.patch -- build against Qt5 libraries
Patch3:         projectM-2.1.0-Qt5.patch
%endif
BuildRequires:  cmake
BuildRequires:  fdupes
BuildRequires:  ftgl-devel
BuildRequires:  glew-devel
BuildRequires:  libSDL-devel
BuildRequires:  libpulse-devel
BuildRequires:  libsndfile-devel
BuildRequires:  libvisual-devel
BuildRequires:  pkgconfig
%if 0%{?_isqt5}
BuildRequires:  pkgconfig(Qt5Core)
BuildRequires:  pkgconfig(Qt5OpenGL)
BuildRequires:  pkgconfig(Qt5Widgets)
BuildRequires:  pkgconfig(Qt5Xml)
%else
BuildRequires:  libqt4-devel
%endif
Recommends:     %{name}-data = %{version}

%description
projectM%{?_isqt5:-qt5} is an awesome music visualizer.

%package     -n lib%{_oname}%{?_isqt5:-qt5-}2
Summary:        Run-time Libraries for ProjectM%{?_isqt5:-qt5}
Group:          System/Libraries

%description -n lib%{_oname}%{?_isqt5:-qt5-}2
projectM%{?_isqt5:-qt5} is an awesome music visualizer.
This package contains its runtime libraries.

%package     -n lib%{_oname}-qt%{?_isqt5:-qt5-}1
Summary:        Qt Run-time Libraries for ProjectM%{?_isqt5:-qt5}
Group:          System/Libraries

%description -n lib%{_oname}-qt%{?_isqt5:-qt5-}1
projectM%{?_isqt5:-qt5} is an awesome music visualizer.
This package contains its qt runtime libraries.

%package     -n lib%{_oname}-libvisual%{?_isqt5:-qt5}
Summary:        Libvisual Collaboration for ProjectM%{?_isqt5:-qt5}
Group:          System/Libraries

%description -n lib%{_oname}-libvisual%{?_isqt5:-qt5}
projectM%{?_isqt5:-qt5} is an awesome music visualizer.
This package contains its libvisual collaboration libraries.

%package        data
Summary:        Data files for ProjectM%{?_isqt5:-qt5}
Group:          Productivity/Multimedia/Sound/Visualization
Requires:       %{name} = %{version}
Requires:       dejavu

%description    data
projectM%{?_isqt5:-qt5} is an awesome music visualizer.
This package contains its data: config, presets, shaders.

%package        devel
Summary:        Development Files for ProjectM%{?_isqt5:-qt5}
Group:          Development/Libraries/C and C++
Requires:       %{name} = %{version}
Requires:       %{name}-data = %{version}
Requires:       lib%{_oname}%{?_isqt5:-qt5-}2 = %{version}
Requires:       lib%{_oname}-qt%{?_isqt5:-qt5-}1 = %{version}

%description    devel
projectM%{?_isqt5:-qt5} is an awesome music visualizer.
This package contains its development files.

%prep
%setup -q -n %{_oname}-complete-%{version}-Source
%patch0 -p1
%patch1 -p1
%patch2 -p1
%if 0%{?_isqt5}
%patch3 -p1
%endif

rm -r src/WinLibs # legal issues, see bnc#738417, we don't need that whole tree

%build
#projectM-test has runtime problems, I don't know how to fix it, so I disable it
%cmake -DINCLUDE-PROJECTM-TEST=OFF
make %{?_smp_mflags}

%install
%cmake_install
find %{buildroot} -name *.la -delete
%fdupes %{buildroot}

%post -n lib%{_oname}%{?_isqt5:-qt5-}2 -p /sbin/ldconfig
%post -n lib%{_oname}-qt%{?_isqt5:-qt5-}1 -p /sbin/ldconfig
%post -n lib%{_oname}-libvisual%{?_isqt5:-qt5} -p /sbin/ldconfig
%postun -n lib%{_oname}%{?_isqt5:-qt5-}2 -p /sbin/ldconfig
%postun -n lib%{_oname}-qt%{?_isqt5:-qt5-}1 -p /sbin/ldconfig
%postun -n lib%{_oname}-libvisual%{?_isqt5:-qt5} -p /sbin/ldconfig

%files
%defattr(-,root,root)
%{_bindir}/%{_oname}-pulseaudio%{?_isqt5:-qt5}
%{_datadir}/applications/%{_oname}-pulseaudio%{?_isqt5:-qt5}.desktop
%{_datadir}/pixmaps/*

%files -n lib%{_oname}%{?_isqt5:-qt5-}2
%defattr(-,root,root)
%{_libdir}/lib%{_oname}%{?_isqt5:-qt5}.so.%{version}

%files -n lib%{_oname}-qt%{?_isqt5:-qt5-}1
%defattr(-,root,root)
%{_libdir}/lib%{_oname}-qt%{?_isqt5:-qt5}.so.1.10

%files -n lib%{_oname}-libvisual%{?_isqt5:-qt5}
%defattr(-,root,root)
%{_libdir}/libvisual-0.4%{?_isqt5:-qt5}/

%files data
%defattr(-,root,root)
%{_datadir}/%{name}/

%files devel
%defattr(-,root,root)
%{_includedir}/lib%{_oname}%{?_isqt5:-qt5}
%{_includedir}/lib%{_oname}-qt%{?_isqt5:-qt5}
%{_libdir}/lib%{_oname}%{?_isqt5:-qt5}.so
%{_libdir}/lib%{_oname}%{?_isqt5:-qt5}.so.2
%{_libdir}/lib%{_oname}-qt%{?_isqt5:-qt5}.so
%{_libdir}/lib%{_oname}-qt%{?_isqt5:-qt5}.so.1
%{_libdir}/pkgconfig/*

%changelog
* Wed Jul 26 2017 aloisio@gmx.com
- Spec cleanup (use %%cmake macros)
- Added projectM-2.1.0-no-return-in-nonvoid.patch and
  projectM-2.1.0-SUSE_misc.patch
- Obtain official tarball from sourceforge
- Dropped FindGLEW.cmake (no current target needs it)
- Added separate -qt5 version of the package and
  projectM-2.1.0-Qt5.patch and pre_checkin.sh to support the
  latter
* Mon May 23 2016 antoine.belvire@laposte.net
- Fix build with GCC6:
  * Add projectM-2.1.0-fix-isnan-gcc6.patch
* Thu Dec 11 2014 olaf@aepfle.de
- Correct usage of fdupes macro
* Tue Jun 25 2013 i@marguerite.su
- fix bnc#825162: Error in standard configuration File causes projectM not to start
* Sun Mar 24 2013 schwab@suse.de
- Properly determine list of lib64 platforms
* Thu May 24 2012 i@marguerite.su
- update version 2.1.0
  * Fixed several memory leaks (when projectM gets destroyed, or when a preset gets destroyed)
  * Resolved some parser errors and an embarrasing evaluation bug (in particular, 2^x does not equal x^2)
  * +/- keys support to edit the ratings
  * libvisual / gstreamer compatible
  * Various cmake build fixes and improvements
- drop two patches. upstream fixed.
* Sat May 12 2012 reddwarf@opensuse.org
- fix the version in the pkg-config file
* Tue Mar 27 2012 dvaleev@suse.com
- fix ppc64 build
* Tue Jan  3 2012 saschpe@suse.de
- Remove licenses from subpackages (inherited anyways)
- Remove src/WinLibs tree (bnc#738417)
* Sat Dec 31 2011 prusnak@opensuse.org
- spec cleanup
- fix font locations in config.inp
* Sat Dec 10 2011 i@marguerite.su
- initial package 2.0.1+ from git
- split libraries and data
